/**

Copyright ( 2001 The University of Kansas
COPYRIGHT AND LIMITATION ON USE
The documents and software (collectively the "Information") developed by the University of Kansas, Information and Telecommunication Technology Center (Hereinafter referred to as KU) is the property of KU or its licensors and is protected by copyright and other intellectual property laws. The information may be viewed, copied, run, modified or printed for educational and research purposes only and shall not be published, sold, broadcast, or redistributed, either directly or indirectly, in whole or in part, by any means or methods for commercial purposes. The Information may not be used for any purpose not expressly approved herein. Uses not approved include, but are not limited to, commercial distribution, in whole or in part.  Any rights not expressly granted herein are reserved by KU. 

Nothing contained herein shall be construed as conferring by implication, estoppel or otherwise any license or right under any patent or trademark of KU or any third party. Except as expressly provided above, nothing contained herein shall be construed as conferring any license or right under any KU copyright. 

DISCLAIMER OF WARRANTY
Use of the  information is at your sole risk. The information, is provided "AS IS" and without warranty of any kind and KU  AND ITS AFFILIATES, AGENTS AND LICENSORS , EXPRESSLY DISCLAIM ALL WARRANTIES, EXPRESS or IMPLIED, INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND OF FITNESS FOR A PARTICULAR PURPOSE AND ANY EXPRESS OR IMPLIED WARRANTY AGAINST INFRINGEMENT. KU DOES NOT WARRANT THAT THE FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET YOUR REQUIREMENTS, OR THAT THE OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR-FREE, OR THAT DEFECTS IN THE SOFTWARE WILL BE CORRECTED. FURTHERMORE, KU DOES NOT WARRANT OR MAKE ANY REPRESENTATIONS REGARDING THE USE OR THE RESULTS OF THE USE OF THE SOFTWARE OR ITS DOCUMENTATION IN TERMS OF THEIR CORRECTNESS, ACCURACY, RELIABILITY, OR OTHERWISE. NO ORAL OR WRITTEN INFORMATION OR ADVICE GIVEN BY KU OR A KU AUTHORIZED REPRESENTATIVE SHALL CREATE A WARRANTY OR IN ANY WAY INCREASE THE SCOPE OF THIS WARRANTY. SHOULD THE SOFTWARE PROVE DEFECTIVE, YOU (AND NOT KU), ASSUMES THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 

LIMITATION OF LIABILITY

NEITHER KU NOR ANY OF ITS AFFILIATES, AGENTS OR REPRESENTATIVES WILL BE LIABLE FOR ACTUAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES (INCLUDING LOSS OF PROFITS, LOSS OF BUSINESS OR SAVINGS), EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. IN NO EVENT WILL KU BE LIABLE FOR ANY ACTUAL, SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER, WHETHER IN AN ACTION OF CONTRACT, TORT OR ACTION OF ANY KIND, ARISING OUT OF OR IN CONNECTION WITH THE USE OF THE INFORMATION.  KU, ITS AFFILIATES, AGENTS AND REPRESENTATIVES WILL NOT BE LIABLE FOR NEGLIGENCE, RECKLESSNESS, INTENTIONAL MISCONDUCT OR ANY OTHER ACTS OR OMISSIONS OF THIRD PARTIES. 
GOVERNING LAW
This Agreement, all intellectual property issues, and your rights and obligations shall be governed by the laws of the United States of America and the State of Kansas, excluding their conflicts of laws rules. 


**/

/*---------------------------------------------------------------------------*/
/*                                                                           */
/* Program: MySystem.java                                                    */
/*                                                                           */
/* Purpose: This class contains system interface routines.                   */
/*                                                                           */
/* Author:  Edu Metz                                                         */
/*                                                                           */
/* Date:    January 27, 1997                                                 */
/*                                                                           */
/*---------------------------------------------------------------------------*/
package magician.Node;
import java.lang.*;
import java.io.*;


public final class MySystem {


   /*-----------------------------------*/
   /* Print an error message and aborts */
   /*-----------------------------------*/
   public static void error(String message) {
      System.err.println(message);
      System.exit(-1);
   }


   /*----------------------------*/
   /* Print an message to stdout */
   /*----------------------------*/
   public static void println(String message) {
      System.out.println(message);
   }


   /*---------------------------*/
   /* Exit the java application */
   /*---------------------------*/
   public static void exit(int status) {
      System.exit(status);
   }


   /*------------------*/
   /* Read from a file */
   /*------------------*/
   public static int readFile(String fileName, byte[] buffer, int count) {
      int bytesRead = 0;

      try {
         /* Create a file input stream */	
         FileInputStream in = new FileInputStream(fileName);

	 /* Read the bytes */
         bytesRead = in.read(buffer, 0, count);

	 /* Close this file input stream */
         in.close();
      }
      catch (FileNotFoundException e) {
         MySystem.error("Error: file " + fileName + " not found");
      }
      catch (IOException e) {
	 MySystem.error("Error: reading from file " + fileName);
      }

      return(bytesRead);
   }


   /*-----------------*/
   /* Write to a file */
   /*-----------------*/
   public static void writeFile(String fileName, byte[] buffer, int count) {

      try {
	 /* Create a file output stream */
	 FileOutputStream out = new FileOutputStream(fileName);

	 /* Write the bytes */
	 out.write(buffer, 0, count);

	 /* Close this file input stream */
	 out.close();
      } 
      catch (IOException e) {
	 MySystem.error("Error: writing to file " + fileName);
      }
   }


   /*--------------------------------*/
   /* convert a string into a number */
   /*--------------------------------*/
   public static int atoi(String s) {
      int n = 0;

      try {
         n = new Integer(s.trim()).intValue();
      } catch(NumberFormatException e) {
	 MySystem.error("Error: atoi");
      }
      return (n);
   }
}
