/**

Copyright ( 2001 The University of Kansas
COPYRIGHT AND LIMITATION ON USE
The documents and software (collectively the "Information") developed by the University of Kansas, Information and Telecommunication Technology Center (Hereinafter referred to as KU) is the property of KU or its licensors and is protected by copyright and other intellectual property laws. The information may be viewed, copied, run, modified or printed for educational and research purposes only and shall not be published, sold, broadcast, or redistributed, either directly or indirectly, in whole or in part, by any means or methods for commercial purposes. The Information may not be used for any purpose not expressly approved herein. Uses not approved include, but are not limited to, commercial distribution, in whole or in part.  Any rights not expressly granted herein are reserved by KU. 

Nothing contained herein shall be construed as conferring by implication, estoppel or otherwise any license or right under any patent or trademark of KU or any third party. Except as expressly provided above, nothing contained herein shall be construed as conferring any license or right under any KU copyright. 

DISCLAIMER OF WARRANTY
Use of the  information is at your sole risk. The information, is provided "AS IS" and without warranty of any kind and KU  AND ITS AFFILIATES, AGENTS AND LICENSORS , EXPRESSLY DISCLAIM ALL WARRANTIES, EXPRESS or IMPLIED, INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND OF FITNESS FOR A PARTICULAR PURPOSE AND ANY EXPRESS OR IMPLIED WARRANTY AGAINST INFRINGEMENT. KU DOES NOT WARRANT THAT THE FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET YOUR REQUIREMENTS, OR THAT THE OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR-FREE, OR THAT DEFECTS IN THE SOFTWARE WILL BE CORRECTED. FURTHERMORE, KU DOES NOT WARRANT OR MAKE ANY REPRESENTATIONS REGARDING THE USE OR THE RESULTS OF THE USE OF THE SOFTWARE OR ITS DOCUMENTATION IN TERMS OF THEIR CORRECTNESS, ACCURACY, RELIABILITY, OR OTHERWISE. NO ORAL OR WRITTEN INFORMATION OR ADVICE GIVEN BY KU OR A KU AUTHORIZED REPRESENTATIVE SHALL CREATE A WARRANTY OR IN ANY WAY INCREASE THE SCOPE OF THIS WARRANTY. SHOULD THE SOFTWARE PROVE DEFECTIVE, YOU (AND NOT KU), ASSUMES THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 

LIMITATION OF LIABILITY

NEITHER KU NOR ANY OF ITS AFFILIATES, AGENTS OR REPRESENTATIVES WILL BE LIABLE FOR ACTUAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES (INCLUDING LOSS OF PROFITS, LOSS OF BUSINESS OR SAVINGS), EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. IN NO EVENT WILL KU BE LIABLE FOR ANY ACTUAL, SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER, WHETHER IN AN ACTION OF CONTRACT, TORT OR ACTION OF ANY KIND, ARISING OUT OF OR IN CONNECTION WITH THE USE OF THE INFORMATION.  KU, ITS AFFILIATES, AGENTS AND REPRESENTATIVES WILL NOT BE LIABLE FOR NEGLIGENCE, RECKLESSNESS, INTENTIONAL MISCONDUCT OR ANY OTHER ACTS OR OMISSIONS OF THIRD PARTIES. 
GOVERNING LAW
This Agreement, all intellectual property issues, and your rights and obligations shall be governed by the laws of the United States of America and the State of Kansas, excluding their conflicts of laws rules. 


**/
package magician.Node;

import java.io.*;
import java.util.*;

public class predictor implements PredictorItf {
    
    static final int LOW_FIDELITY = 0;
    static final int MEDIUM_FIDELITY = 1;
    static final int HIGH_FIDELITY = 2;
    
    static final int P80 = 0;
    static final int P85 = 1;
    static final int P90 = 2;
    static final int P95 = 3;
    static final int P99 = 4;
    
    int fidelity = MEDIUM_FIDELITY;
    
    private prediction[] mean;
    private prediction[] stddev;
    private prediction[][] percentile;
    
    public predictor(String appClass) throws FileNotFoundException {
	
	mean = new prediction[3];
	stddev = new prediction[3];
	percentile = new prediction[3][5];
	
	
	BufferedReader traceFile;
	String traceLine = "";
	
	traceFile = new BufferedReader(new FileReader("../Node/"+appClass+".stats"));


	try {
	    traceLine = traceFile.readLine();
	    StringTokenizer st = new StringTokenizer(traceLine);
	    float value = (new Float(st.nextToken())).floatValue();
	    int error = (new Integer(st.nextToken())).intValue();
	    mean[LOW_FIDELITY] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    mean[MEDIUM_FIDELITY] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    mean[HIGH_FIDELITY] = new prediction(value, error);
	    
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    stddev[LOW_FIDELITY] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    stddev[MEDIUM_FIDELITY] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    stddev[HIGH_FIDELITY] = new prediction(value, error);

	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[LOW_FIDELITY][P80] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[MEDIUM_FIDELITY][P80] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[HIGH_FIDELITY][P80] = new prediction(value, error);

	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[LOW_FIDELITY][P85] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[MEDIUM_FIDELITY][P85] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[HIGH_FIDELITY][P85] = new prediction(value, error);

	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[LOW_FIDELITY][P90] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[MEDIUM_FIDELITY][P90] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[HIGH_FIDELITY][P90] = new prediction(value, error);

	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[LOW_FIDELITY][P95] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[MEDIUM_FIDELITY][P95] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[HIGH_FIDELITY][P95] = new prediction(value, error);

	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[LOW_FIDELITY][P99] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[MEDIUM_FIDELITY][P99] = new prediction(value, error);
	    traceLine = traceFile.readLine();
	    st = new StringTokenizer(traceLine);
	    value = (new Float(st.nextToken())).floatValue();
	    error = (new Integer(st.nextToken())).intValue();
	    percentile[HIGH_FIDELITY][P99] = new prediction(value, error);

	    traceFile.close();
	} catch (Exception e) {
	    System.out.println("Error! " + e );
            e.printStackTrace();
	}
    }
    
    public void setFidelity(int fidel) {
	if ((fidel != 0) & (fidel != 1) & (fidel != 2)) {
	    System.out.println("Usage: setFidelity(param) where param=0 for LOW_FIDELITY, param=1 for MEDIUM_FIDELITY (default) or param=2 for HIGH_FIDELITY.");
	    fidel = MEDIUM_FIDELITY;
	} else {
	    fidelity = fidel;
	}
    }
    
    
    public prediction getMean() {
	return mean[fidelity];
    }
    
    public prediction getStdDev() {
	return stddev[fidelity];
    }
    
    public prediction getPercentile(int perc) {
	switch (perc) {
	case 80: return percentile[fidelity][P80];
	case 85: return percentile[fidelity][P85];
	case 90: return percentile[fidelity][P90];
	case 95: return percentile[fidelity][P95];
	case 99: return percentile[fidelity][P99];
	default: {
	    System.out.println("Percentiles available: 80th, 85th, 90th, 95th and 99th");
	    return new prediction(-1,100);
	} 
	}
    }

    
}







